"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Middleware = void 0;
const koa_send_1 = __importDefault(require("koa-send"));
const fs_1 = require("fs");
const path_1 = require("path");
const os_1 = require("os");
const ejs_1 = require("ejs");
const assetsDir = (0, path_1.join)(__dirname, '..', '..');
let tmpDir = null;
function serveIndex(ctx, basePath) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!tmpDir) {
            tmpDir = yield fs_1.promises.mkdtemp((0, path_1.join)((0, os_1.tmpdir)(), 'redis-smq-monitor-'));
        }
        const indexHTML = (0, path_1.join)(tmpDir, 'index.html');
        try {
            yield fs_1.promises.access(indexHTML, fs_1.constants.F_OK);
        }
        catch (_a) {
            const html = yield (0, ejs_1.renderFile)((0, path_1.join)(assetsDir, 'assets', 'index.html'), { basePath });
            yield fs_1.promises.writeFile(indexHTML, html);
        }
        yield (0, koa_send_1.default)(ctx, 'index.html', { root: tmpDir });
    });
}
const Middleware = (ignorePaths = [], basePath = '/') => (ctx, next) => __awaiter(void 0, void 0, void 0, function* () {
    if (!ignorePaths.length ||
        ignorePaths.find((i) => {
            const match = path_1.posix.join('/', basePath, i).replace(/\/+$/, '');
            return ctx.path.indexOf(match) === 0;
        }) === undefined) {
        yield ('/' === ctx.path || ctx.path.indexOf('/assets/') !== 0
            ? serveIndex(ctx, basePath)
            : (0, koa_send_1.default)(ctx, ctx.path, { root: assetsDir }));
    }
    else
        yield next();
});
exports.Middleware = Middleware;
//# sourceMappingURL=middleware.js.map